namespace CCI.CrestronHomeBridge.SharedLibrary;
        // class declarations
         class Constants;
         class PageType;
         class TileFunction;
         class ParentType;
         class IntersystemMessageCategory;
         class IntersystemMessage;
         class IntersystemQueue;
         class JsonSerializationSettingsFactory;
         class DpadDirectionMap;
         class AUiElement;
         class AUiEnableVisible;
         class AUiVisible;
         class UiFeedback;
         class UiFeedbackSerial;
         class UiFeedbackDigital;
         class UiFeedbackAnalog;
         class UiFeedbackSignedAnalog;
         class UiButton;
         class UiButtonGroup;
         class UiCheckbox;
         class UiControlGroup;
         class UiDefinition;
         class UiDirectionalKeypad;
         class UiKeypad;
         class UiLayout;
         class UiRadialGaugeSigned;
         class UiRadialGauge;
         class UiRaiseLowerWithTextSigned;
         class UiRaiseLowerWithText;
         class UiSubheader;
         class UiTextDisplay;
         class UiTextEntry;
         class UiTile;
         class UiToggle;
         class UiToggleSliderSigned;
         class UiToggleSlider;
    static class Constants 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        static INTEGER MAX_KEYPAD_BUTTONS;

        // class properties
    };

    static class PageType // enum
    {
        static SIGNED_LONG_INTEGER Room;
        static SIGNED_LONG_INTEGER Home;
        static SIGNED_LONG_INTEGER Both;
        static SIGNED_LONG_INTEGER Neither;
        static SIGNED_LONG_INTEGER Unknown;
    };

    static class TileFunction // enum
    {
        static SIGNED_LONG_INTEGER Navigation;
        static SIGNED_LONG_INTEGER Action;
        static SIGNED_LONG_INTEGER Both;
        static SIGNED_LONG_INTEGER Unknown;
    };

    static class ParentType // enum
    {
        static SIGNED_LONG_INTEGER Layout;
        static SIGNED_LONG_INTEGER ButtonGroup;
        static SIGNED_LONG_INTEGER ControlGroup;
        static SIGNED_LONG_INTEGER Unknown;
    };

    static class IntersystemMessageCategory // enum
    {
        static SIGNED_LONG_INTEGER Init;
        static SIGNED_LONG_INTEGER Ui;
        static SIGNED_LONG_INTEGER Tile;
        static SIGNED_LONG_INTEGER Layout;
        static SIGNED_LONG_INTEGER ButtonGroup;
        static SIGNED_LONG_INTEGER ControlGroup;
        static SIGNED_LONG_INTEGER Button;
        static SIGNED_LONG_INTEGER TextDisplay;
        static SIGNED_LONG_INTEGER ToggleSlider;
        static SIGNED_LONG_INTEGER ToggleSliderSigned;
        static SIGNED_LONG_INTEGER Subheader;
        static SIGNED_LONG_INTEGER Checkbox;
        static SIGNED_LONG_INTEGER Toggle;
        static SIGNED_LONG_INTEGER TextEntry;
        static SIGNED_LONG_INTEGER DirectionalKeypad;
        static SIGNED_LONG_INTEGER Keypad;
        static SIGNED_LONG_INTEGER RadialGauge;
        static SIGNED_LONG_INTEGER RadialGaugeSigned;
        static SIGNED_LONG_INTEGER RaiseLowerWithText;
        static SIGNED_LONG_INTEGER RaiseLowerWithTextSigned;
        static SIGNED_LONG_INTEGER Unknown;
    };

     class JsonSerializationSettingsFactory 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

     class DpadDirectionMap 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        static CCI.CrestronHomeBridge.SharedLibrary.DpadDirectionMap UNKNOWN;
        static CCI.CrestronHomeBridge.SharedLibrary.DpadDirectionMap UP;
        static CCI.CrestronHomeBridge.SharedLibrary.DpadDirectionMap DOWN;
        static CCI.CrestronHomeBridge.SharedLibrary.DpadDirectionMap LEFT;
        static CCI.CrestronHomeBridge.SharedLibrary.DpadDirectionMap RIGHT;
        static CCI.CrestronHomeBridge.SharedLibrary.DpadDirectionMap CENTER;

        // class properties
        INTEGER index;
        STRING cmd[];
    };

     class AUiElement 
    {
        // class delegates

        // class events

        // class functions
        FUNCTION Dispose ();
        STRING_FUNCTION ToString ();
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();

        // class variables
        INTEGER __class_id__;

        // class properties
        STRING Id[];
    };

     class AUiEnableVisible 
    {
        // class delegates

        // class events

        // class functions
        FUNCTION Dispose ();
        STRING_FUNCTION ToString ();
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();

        // class variables
        INTEGER __class_id__;

        // class properties
        STRING Id[];
    };

     class AUiVisible 
    {
        // class delegates

        // class events

        // class functions
        FUNCTION Dispose ();
        STRING_FUNCTION ToString ();
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();

        // class variables
        INTEGER __class_id__;

        // class properties
        STRING Id[];
    };

